execute if entity @s[scores={venom=1..,venom_click=1..},nbt={SelectedItemSlot:8},predicate=venom:offhand] run function venom:morph/into_venom
function venom:actionbar
function venom:remove_venom
execute if entity @s[scores={venom_morph=1,venom_click=1..},nbt={SelectedItemSlot:7}] unless predicate venom:sneaking run function venom:raycast
execute if entity @s[scores={venom_morph=1,venom_click=1..},nbt={SelectedItemSlot:7},predicate=venom:sneaking] run function venom:grapple
execute if entity @s[scores={venom_morph=1}] run tag @s add no_grab

#raycast
execute as @e[tag=venom_grab] at @s if block ~ ~ ~ #passable run tp ^ ^ ^0.9
execute as @e[tag=venom_grab] at @s if block ~ ~ ~ #flowers run tp ^ ^ ^0.9
execute as @e[tag=venom_grab] at @s if block ~ ~ ~ bell run fill ~ ~ ~ ~ ~ ~ bell destroy
execute as @e[tag=venom_grab] at @s if block ~ ~ ~ bell run fill ~ ~ ~ ~ ~ ~ air replace bell
execute as @e[tag=venom_grab] at @s if block ~ ~ ~ crafting_table run fill ~ ~ ~ ~ ~ ~ crafting_table destroy
execute as @e[tag=venom_grab] at @s if block ~ ~ ~ crafting_table run fill ~ ~ ~ ~ ~ ~ air replace crafting_table
execute at @e[tag=venom_grab] run particle minecraft:dust 0 0 0 2 ~ ~ ~ 0 0 0 0 50 force
execute at @e[tag=venom_grab] if entity @e[tag=!no_grab,type=!area_effect_cloud,distance=..2,limit=1] store success entity @e[tag=venom_grab,limit=1] Duration int 0 run tp @e[tag=!no_grab,distance=..2,limit=1,type=!area_effect_cloud] @p[scores={venom_morph=1},sort=nearest,limit=1]

#grapple
execute as @e[tag=venom_grapple] at @s if block ~ ~ ~ #passable run tp ^ ^ ^1
execute as @e[tag=venom_grapple] at @s if block ~ ~ ~ #flowers run tp ^ ^ ^1
execute as @e[tag=venom_grapple] run tp @p[scores={venom_morph=1},sort=nearest,limit=1] @s
execute if entity @s[scores={venom_morph=1}] if entity @e[tag=venom_grapple,distance=..1] at @s run particle minecraft:dust 0 0 0 2 ^ ^ ^5 0 0 0 0 50 force

#morph effects
execute if entity @s[scores={venom_morph=1}] run effect give @s regeneration 1 1 true
execute if entity @s[scores={venom_morph=1}] run effect give @s resistance 1 2 true
execute if entity @s[scores={venom_morph=1}] run effect give @s speed 1 2 true
execute if entity @s[scores={venom_morph=1}] run effect give @s invisibility 1 0 true
execute if entity @s[scores={venom_morph=1}] run effect give @s night_vision 20 0 true
execute unless entity @s[scores={venom_morph=1}] run effect clear @s night_vision
execute if entity @s[scores={venom_morph=1}] run effect give @s strength 1 2 true
execute if entity @s[scores={venom_morph=1}] run effect give @s dolphins_grace 1 2 true

#item replace
execute if entity @s[scores={venom=1..},nbt={SelectedItemSlot:8}] run item replace entity @s weapon.offhand with warped_fungus_on_a_stick{display:{Name:"{\"text\": \"\"}"},venom_power:1b,CustomModelData:1}
execute if entity @s[scores={venom_morph=1},nbt={SelectedItemSlot:7}] run item replace entity @s weapon.offhand with warped_fungus_on_a_stick{display:{Name:"{\"text\": \"\"}"},venom_power:1b,CustomModelData:1}

#walking
execute if entity @s[scores={venom_morph=1,venom_walk=1..}] run item replace entity @s armor.head with netherite_ingot{display:{Name:"{\"text\": \"\"}"},venom_power:1b,CustomModelData:2}
execute if entity @s[scores={venom_morph=1},predicate=venom:sprinting] run item replace entity @s armor.head with netherite_ingot{display:{Name:"{\"text\": \"\"}"},venom_power:1b,CustomModelData:2}

#head
execute if entity @s[scores={venom_morph=1}] unless score @s venom_walk matches 1.. unless predicate venom:sprinting run item replace entity @s armor.head with netherite_ingot{display:{Name:"{\"text\": \"\"}"},venom_power:1b,CustomModelData:1}

#clear items
execute if entity @s[scores={venom=1..}] unless entity @s[nbt={SelectedItemSlot:8}] unless score @s venom_morph matches 1.. run clear @s warped_fungus_on_a_stick{venom_power:1b}
execute if entity @s[scores={venom_morph=1..}] unless entity @s[nbt={SelectedItemSlot:8}] unless entity @s[nbt={SelectedItemSlot:7}] unless entity @s[nbt={SelectedItemSlot:6}] unless entity @s[nbt={SelectedItemSlot:5}] run clear @s warped_fungus_on_a_stick{venom_power:1b}

#player
execute unless score @s venom_morph matches 1.. run clear @s netherite_ingot{venom_power:1b}
execute unless score @s venom matches 1.. run clear @s warped_fungus_on_a_stick{venom_power:1b}

#cooldown score
execute if entity @s[scores={venom_cooldown=1..}] run scoreboard players add @s venom_cooldown 1
execute if entity @s[scores={venom_cooldown=20..20}] run scoreboard players reset @s venom_cooldown
execute if entity @s[scores={venom_morph=2..}] run scoreboard players reset @s venom_morph
execute if entity @s[scores={venom_cooldown=1..},nbt={SelectedItemSlot:8}] at @s run particle minecraft:dust 0 0 0 2 ~ ~1.5 ~ 0.6 1 0.6 1 50 force
execute if entity @s[scores={venom_walk=1..}] run scoreboard players reset @s venom_walk
execute unless entity @s[scores={venom_morph=1}] run tag @s remove no_grab

#on fire
execute if entity @s[scores={venom_morph=1},predicate=venom:on_fire] run scoreboard players set @s venom_morph 2

#weapons
execute if entity @s[scores={venom_morph=1},nbt={SelectedItemSlot:6}] run title @s actionbar {"text": "Blade And Shield","color": "dark_gray"}
execute if entity @s[scores={venom_morph=1},nbt={SelectedItemSlot:6}] run item replace entity @s weapon.mainhand with netherite_sword{CustomModelData:1,display:{Name:"{\"text\": \"\"}"},venom_power:1b,Unbreakable:1b}
execute if entity @s[scores={venom_morph=1},nbt={SelectedItemSlot:6}] run item replace entity @s weapon.offhand with shield{CustomModelData:1,display:{Name:"{\"text\": \"\"}"},venom_power:1b,Unbreakable:1b}
execute unless entity @s[scores={venom_morph=1},nbt={SelectedItemSlot:6}] run clear @s netherite_sword{venom_power:1b}
execute unless entity @s[scores={venom_morph=1},nbt={SelectedItemSlot:6}] run clear @s shield{venom_power:1b}

#kill entity
execute if entity @s[scores={venom_morph=1}] if entity @e[tag=venom_grapple,distance=..1,limit=1] run effect give @s slow_falling 1 0 true
execute unless entity @s[scores={venom_morph=1},predicate=venom:sneaking] run kill @e[tag=venom_grapple,distance=..1]
kill @e[type=item,nbt={Item:{tag:{venom_power:1b}}}]

#eat entity
execute if entity @s[scores={venom_morph=1},nbt={SelectedItemSlot:5}] run item replace entity @s weapon.offhand with warped_fungus_on_a_stick{CustomModelData:1,display:{Name:"{\"text\": \"\"}"},venom_power:1b,Unbreakable:1b}
execute if entity @s[scores={venom_morph=1},nbt={SelectedItemSlot:5}] run title @s actionbar {"text": "Eat Entity","color": "dark_gray"}
execute if entity @s[scores={venom_morph=1,venom_click=1..},nbt={SelectedItemSlot:5},predicate=venom:sneaking] if entity @e[type=!player,distance=..2] run effect give @s saturation 1 5 true
execute if entity @s[scores={venom_morph=1,venom_click=1..},nbt={SelectedItemSlot:5},predicate=venom:sneaking] if entity @e[type=!player,distance=..2] at @s run playsound entity.evoker_fangs.attack player @s ~ ~ ~
execute if entity @s[scores={venom_morph=1,venom_click=1..},nbt={SelectedItemSlot:5},predicate=venom:sneaking] if entity @e[type=!player,distance=..2] at @s run particle minecraft:block redstone_block ~ ~1.5 ~ 0.6 1 0.6 1 50 force
execute if entity @s[scores={venom_morph=1,venom_click=1..},nbt={SelectedItemSlot:5},predicate=venom:sneaking] if entity @e[type=creeper,distance=..2] run give @s creeper_head
execute if entity @s[scores={venom_morph=1,venom_click=1..},nbt={SelectedItemSlot:5},predicate=venom:sneaking] if entity @e[type=zombie,distance=..2] run give @s zombie_head
execute if entity @s[scores={venom_morph=1,venom_click=1..},nbt={SelectedItemSlot:5},predicate=venom:sneaking] if entity @e[type=skeleton,distance=..2] run give @s skeleton_skull
execute if entity @s[scores={venom_morph=1,venom_click=1..},nbt={SelectedItemSlot:5},predicate=venom:sneaking] if entity @e[type=wither_skeleton,distance=..2] run give @s wither_skeleton_skull
execute if entity @s[scores={venom_morph=1,venom_click=1..},nbt={SelectedItemSlot:5},predicate=venom:sneaking] if entity @e[type=piglin,distance=..2] run give @s piglin_head
execute if entity @s[scores={venom_morph=1,venom_click=1..},nbt={SelectedItemSlot:5},predicate=venom:sneaking] if entity @e[type=piglin_brute,distance=..2] run give @s piglin_head
execute if entity @s[scores={venom_morph=1,venom_click=1..},nbt={SelectedItemSlot:5},predicate=venom:sneaking] if entity @e[type=!player,distance=..2] run kill @e[type=!player,distance=..2]

#bell
execute if entity @s[scores={use_bell=1..}] if entity @p[scores={venom=1},distance=..10] run effect give @s[scores={venom=1},distance=..10] wither 5 2 true
execute if entity @s[scores={use_bell=1..}] if entity @p[scores={venom=1},distance=..10] run effect give @s[scores={venom=1},distance=..10] darkness 5 0 true
execute if entity @s[scores={use_bell=1..}] if entity @p[scores={venom=1},distance=..10] run effect give @s[scores={venom=1},distance=..10] glowing 5 0 true
execute if entity @s[scores={use_bell=1..}] if entity @p[scores={venom=1},distance=..10] run scoreboard players set @p[scores={venom=1},distance=..10] venom_morph 2
execute if entity @s[scores={use_bell=1..}] if entity @p[scores={venom=1},distance=..10] run scoreboard players add @p[scores={venom=1},distance=..10] venom_cooldown 1
execute if entity @s[scores={use_bell=1..}] run scoreboard players reset @s use_bell